package com.sf.javase.day12.comparable;

import java.util.Arrays;
import java.util.Comparator;

public class GoodsTest {
    public static void main(String[] args) {
        Goods[] goods = new Goods[]{
                new Goods("a",1.1),
                new Goods("b",1.2),
                new Goods("b",1.3),
                new Goods("ac",1.1),
                new Goods("aqq",1.4),
                new Goods("aw",1.3),
        };
        Arrays.sort(goods, new Comparator<Goods>() {
            @Override
            public int compare(Goods o1, Goods o2) {
                if(o1.getPrice() != o2.getPrice()){
                    int compare = Double.compare(o1.getPrice(), o2.getPrice());
                    return (int) (o1.getPrice()*10 - o2.getPrice()*10);
                }else {
                    return o1.getName().compareTo(o2.getName());
                }
            }
        });
        System.out.println(Arrays.toString(goods));
    }
}
